/*  P A S - P. WOLFERS SOFTWARE: V3.1-A1 OF 30-NOV-2014 
  ***  PASCAL II implementation in C. *** */

/* Set specific Macro setting. */
#define CC_TYPE_SW short
#define CC_TYPE_SL   int
#define CC_TYPE_SQ  long long int

/* Include the PAS environment file. */
#include "cpas_defs.h"

/* Define the local data section. */
static Blk( Rd, 248 ) = {
 14,  14, 101, 114, 114,  95, 112, 117, 116,  95, 115, 121, 109,  98, 111, 108,
 63,  63,  47, 104, 111, 109, 101,  47, 112, 105, 101, 114, 114, 101,  47,  83,
111, 102, 116,  47,  99, 112, 115, 104,  95, 107, 105, 116, 115,  47,  99, 112,
 97, 115,  99,  97, 108,  95, 115, 114,  99,  95,  86,  51,  45,  49,  45,  65,
 50,  47,  99, 112,  97, 115,  95,  98,  95,  95, 101, 114, 114,  46, 112,  97,
115,  15,  15, 101, 114, 114,  95,  99, 108, 114,  95, 115, 121, 109,  98, 116,
 97,  98,  10,  10, 101, 114, 114,  95, 103, 101, 116, 109, 115, 103,  11,  11,
101, 114, 114,  95, 100, 105, 115, 112, 108,  97, 121,   2,   2,  32,  40,   5,
  5,  41,  32,  45,  32,  65,   8,   8,  32, 119,  97, 114, 110, 105, 110, 103,
  7,   7, 110,  32, 101, 114, 114, 111, 114,  13,  13,  32, 115, 101, 118, 101,
114, 101,  32, 101, 114, 114, 111, 114,  12,  12,  32, 102,  97, 116,  97, 108,
 32, 101, 114, 114, 111, 114,   3,   3,  32,  35,  32,  20,  20,  32, 105, 115,
 32, 100, 101, 116, 101,  99, 116, 101, 100,  32,  98, 121,  32, 116, 104, 101,
 32,   8,   8,  32, 109, 111, 100, 117, 108, 101,  46,   8,   8,  32,  37,  42,
 43,  42,  43,  42,  32,   8,   8, 101, 114, 114,  95, 105, 110, 105, 116,   0,
  0,   0,   0,   0,   0,   0,   0,   0
};

/* Declaration of global variables. */
UB V_usr_err_flg;
Blk(V_usr_err_file_spc, 136 ) = {
128,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0 };
Blk(V_msg_err_file_spc, 136 ) = {
128,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   0,   0,   0,   0,   0 };
UB V_error_result;
Blk(V_error_cnt, 24 );
Blk(V_errsymb_tab, 136 );
UL V_errsymb_cnt;

/* Function/procedure prototypes. */
void PAS__ERROR_GETMSG(SL F_n, V F_msgstr, V F_msgfil);


/* Procedure/Function : " err_put_symbol "  */
void P_err_put_symbol(V F_symb, SL F_len){
  /* Define the automatic variable space. */
  Blk( Ra, 16 );

  /* Local variable stored in C variable */
  SL Rv0;
  SL Rv1;
  register int Rf0;

  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s;
  Ra.v[2]=Rd.s+16;
  Ra.sl[3]=142; /* line # 142 */
  if (V_errsymb_cnt<4&&F_len>0) {
    V_errsymb_cnt=V_errsymb_cnt+1;
    Rv0=F_len;
    if (Rv0>32) Rv0=32;
    Ra.sl[3]=147; /* line # 147 */
    V_errsymb_tab.c[V_errsymb_cnt*33-33]=(C)Rv0;
    Rv1=1;
    for( Rf0=Rv0;Rf0>0;Rf0-- ) {
      V_errsymb_tab.c[V_errsymb_cnt*33+Rv1-33]=((C *)F_symb)[Rv1-1];
      Rv1++;
    }
  }
  PAS__curr_cntx=Ra.v[0];
}


/* Procedure/Function : " err_clr_symbtab "  */
void P_err_clr_symbtab(){
  /* Define the automatic variable space. */
  Blk( Ra, 16 );


  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s+81;
  Ra.v[2]=Rd.s+16;
  Ra.sl[3]=158; /* line # 158 */
  V_errsymb_cnt=0;
  PAS__curr_cntx=Ra.v[0];
}


/* Procedure/Function : " err_getmsg "  */
void P_err_getmsg(V F_erren){
  /* Define the automatic variable space. */
  Blk( Ra, 536 );

  /* Local variable stored in C variable */
  SL Rv0;
  SL Rv1;
  SL Rv2;
  SL Rv3;
  C Rv4;
  SL Rv5;
  register UB Rv6;
  register int Rf0;

  /* Code of procedure/function */
  Ra.ub[0]=255;
  Ra.ub[257]=255;
  Ra.v[129]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s+516;
  Ra.v[130]=Rd.s+98;
  Ra.v[131]=Rd.s+16;
  Ra.sl[132]=176; /* line # 176 */
  Rv0=((SL *)F_erren)[1];
  if (V_errsymb_cnt>0) {
    if (V_usr_err_flg) PAS__ERROR_GETMSG(Rv0, Ra.s,V_usr_err_file_spc.s);
    else {
      Ra.sl[132]=181; /* line # 181 */
      PAS__ERROR_GETMSG(Rv0, Ra.s,V_msg_err_file_spc.s);
    }
    Rv1=0;
    if (Ra.ub[1]>0) {
      Ra.sl[132]=187; /* line # 187 */
      Rv2=0;
      Rv3=0;
      while (Rv2<Ra.ub[1]&&Rv1<Ra.ub[257]){
        Rv2=Rv2+1;
        Rv4=Ra.c[Rv2+1];
        if (Rv4==96) {
          Ra.sl[132]=193; /* line # 193 */
          Rv3=Rv3+1;
          if (Rv3<=V_errsymb_cnt) {
            Rv5=1;
            for( Rf0=(SL)V_errsymb_tab.c[Rv3*33-33];Rf0>0;Rf0-- ) {
              if (Rv1<Ra.ub[257]) {
                Ra.sl[132]=198; /* line # 198 */
                Rv1=Rv1+1;
                Ra.c[Rv1+258]=V_errsymb_tab.c[Rv3*33+Rv5-33];
              }
              Rv5++;
            }
          }
        }
        else {
          Ra.sl[132]=203; /* line # 203 */
          Rv1=Rv1+1;
          Ra.c[Rv1+258]=Rv4;
        }
      }
    }
    Ra.ub[258]=Rv1;
    Ra.sl[132]=208; /* line # 208 */
    V_errsymb_cnt=0;
  }
  else {
    if (V_usr_err_flg) PAS__ERROR_GETMSG(Rv0, Ra.s+257,V_usr_err_file_spc.s);
    else {
      Ra.sl[132]=213; /* line # 213 */
      PAS__ERROR_GETMSG(Rv0, Ra.s+257,V_msg_err_file_spc.s);
    }
  }
  if (Ra.ub[258]>0) {
    Ra.sl[132]=219; /* line # 219 */
    if (((V *)F_erren)[4]!=NULL) PAS__DISPOSE(((V *)F_erren)+4);
    Rv6=Ra.ub[258];
    ((V *)F_erren)[4]=PAS__NEW((SL)Rv6+2);
    ((UB *)((V *)F_erren)[4])[0]=Rv6;
    PAS__STR_TO_STR(((V *)F_erren)[4],Ra.s+257);
  }
  PAS__curr_cntx=Ra.v[129];
}


/* Procedure/Function : " err_display "  */
void P_err_display(V *F_f, SL F_ie, V F_erren){
  /* Define the automatic variable space. */
  Blk( Ra, 16 );


  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s+110;
  Ra.v[2]=Rd.s+16;
  Ra.sl[3]=234; /* line # 234 */
  PAS__SELECT_OUT((*F_f));
  PAS__WRITE_STR(Rd.s+123,-1,-1,32);
  PAS__WRITE_INT(F_ie,1,0);
  PAS__WRITE_STR(Rd.s+127,-1,-1,32);
  switch (((UB *)F_erren)[8]) {
    case 0:break;
    case 1:Ra.sl[3]=239; /* line # 239 */
    PAS__SELECT_OUT((*F_f));
    PAS__WRITE_STR(Rd.s+134,-1,-1,32);
    break;
    case 2:PAS__SELECT_OUT((*F_f));
    PAS__WRITE_STR(Rd.s+144,-1,-1,32);
    break;
    case 3:PAS__SELECT_OUT((*F_f));
    PAS__WRITE_STR(Rd.s+153,-1,-1,32);
    break;
    case 4:PAS__SELECT_OUT((*F_f));
    PAS__WRITE_STR(Rd.s+168,-1,-1,32);
    break;
  }
  Ra.sl[3]=244; /* line # 244 */
  PAS__SELECT_OUT((*F_f));
  PAS__WRITE_STR(Rd.s+182,-1,-1,32);
  PAS__WRITE_INT(((SL *)F_erren)[1],5,0);
  PAS__WRITE_STR(Rd.s+187,-1,-1,32);
  PAS__WRITE_CHT(F_erren+9,4,-1,-1,32);
  PAS__WRITE_STR(Rd.s+209,-1,-1,32);
  PAS__WRITE_EOLN();
  if (((V *)F_erren)[4]!=NULL) {
    PAS__SELECT_OUT((*F_f));
    PAS__WRITE_STR(Rd.s+219,-1,-1,32);
    PAS__WRITE_STR(((V *)F_erren)[4],-1,-1,32);
    PAS__WRITE_EOLN();
  }
  else {
    PAS__SELECT_OUT((*F_f));
    PAS__WRITE_EOLN();
  }
  PAS__curr_cntx=Ra.v[0];
}


/* Procedure/Function : " err_init "  */
void P_err_init(V F_errf_str){
  /* Define the automatic variable space. */
  Blk( Ra, 16 );

  /* Local variable stored in C variable */
  UB Rv0;
  register int Rf0;

  /* Code of procedure/function */
  Ra.v[0]=PAS__curr_cntx;
  PAS__curr_cntx=Ra.s;
  Ra.v[1]=Rd.s+229;
  Ra.v[2]=Rd.s+16;
  Ra.sl[3]=269; /* line # 269 */
  PAS__STR_TO_STR(V_msg_err_file_spc.s,F_errf_str);
  PAS__STR_TO_STR(V_usr_err_file_spc.s,Rd.s+239);
  V_usr_err_flg=0;
  V_errsymb_cnt=0;
  Ra.sl[3]=274; /* line # 274 */
  Rv0=0;
  for( Rf0=5;Rf0>0;Rf0-- ) {
    V_error_cnt.sl[Rv0]=0;
    Rv0++;
  }
  V_error_result=0;
  PAS__curr_cntx=Ra.v[0];
}
